package cn.net.caoyao.cpzshandset.service.thread.impl.ythLogin;

import java.io.IOException;
import java.net.SocketTimeoutException;
import java.util.List;

import android.os.Handler;
import android.os.Message;

import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.service.bll.UserLoginBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20020ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.ResponsibleUserInfoBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20020ReqUserInfo;

public class YthLoginReqUserInfoRunable implements Runnable {
	private Handler mHandler;
	private long deveicedId; 
	private UserLoginBll loginBll;
	public YthLoginReqUserInfoRunable(Handler mHandler, long deveicedId,UserLoginBll loginBll) {
		this.mHandler = mHandler;
		this.deveicedId = deveicedId;
		this.loginBll = loginBll;
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, String.valueOf(deveicedId));
		try {
			create.createLoginCpzsHandset(deveicedId);
			if (create.isResult()) {
				Prot20020ReqUserInfo userReq = new Prot20020ReqUserInfo();
				userReq.dealUserInfoList(create);
				Prot20020ResBean resBean = userReq.getUserInfo();
				if (resBean.getResult() == 0) {
					//0：请求成功     1：遇到错误信息，返回错误码
					if (resBean.getUser() != null && resBean.getUser().size()>0) {
						insertUserInfo(resBean.getUser());
					}else {
						mHandler.sendEmptyMessage(RequestConstant.PROT_REQ_USERINFO_20020_NO_DATA);
					}
				} else {
					Message failMsg = mHandler.obtainMessage();
					failMsg.what = RequestConstant.PROT_REQ_USERINFO_20020_FAIL;
					failMsg.obj = resBean;
					mHandler.sendMessage(failMsg);
				}
				
			} else {
//				mHandler.sendEmptyMessage(ThreadConstant.)
				Message loginFailMsg = mHandler.obtainMessage();
				loginFailMsg.obj = create.getErrMsg();
				loginFailMsg.arg1 = create.getiErrCode();
				loginFailMsg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				mHandler.sendMessage(loginFailMsg);
			}
		}catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} finally{
			new Prot02Logout().dealLogout(create);
		}
	}

	private void insertUserInfo(List<ResponsibleUserInfoBean> userInfoBeans) {
		loginBll.deleteAllUserInfo();
		loginBll.insertUserInfoList(userInfoBeans);
		mHandler.sendEmptyMessage(RequestConstant.PROT_REQ_USERINFO_20020_SUCCESS);
	}

}
